const CONFIG_PATH = "./plugins/notice/Config.json";
function loadAnnouncementContent() {
    const defaultContent = "欢迎来到服务器，这里可以自定义公告内容...";
    const content = File.readFrom(CONFIG_PATH);
    return content ? JSON.parse(content).announcement : defaultContent;
}
function saveAnnouncementContent(content) {
    File.writeTo(CONFIG_PATH, JSON.stringify({ announcement: content }));
}

mc.listen("onJoin", function(player) {
    sendAnnouncement(player, "§l§e公告", loadAnnouncementContent());
});

mc.regPlayerCmd("公告", "§l打开公告管理表单", function(player) {   //指令{公告}打开表单
    if (!player.isOP()) return player.sendText("§c你没有权限使用此命令。");

    player.sendModalForm(
        "§e公告管理",
        "§e请选择一个操作：",
        "§e即时公告",
        "§e修改公告",
        (pl, result) => {
            result ? showImmediateAnnouncementOptions(pl) : showAnnouncementEditForm(pl);
        }
    );
});

function showImmediateAnnouncementOptions(player) {
    player.sendModalForm(
        "§e即时发送公告",
        "§e请选择公告类型：",
        "§e全服公告",
        "§e对单个玩家公告",
        (pl, result) => {
            result ? createAnnouncementForm(pl, true) : selectPlayerForAnnouncement(pl);
        }
    );
}
function showAnnouncementEditForm(player) {
    const form = mc.newCustomForm()
        .setTitle("§e修改公告内容")
        .addInput("§a公告内容", "§e请输入公告内容", loadAnnouncementContent());

    player.sendForm(form, (pl, data) => {
        if (data) {
            saveAnnouncementContent(data[0]);
            pl.sendText("§a公告内容已更新，下次玩家加入时将显示新内容。");
        }
    });
}
function sendAnnouncement(target, title, content, callback = null) {
    target.sendModalForm(
        title,
        content,
        "§a我知道了",
        "§c关闭",
        callback || ((pl, result) => {
            if (result) pl.sendText("感谢你的理解和支持！");
        })
    );
}
function createAnnouncementForm(player, isGlobal, targetPlayer = null) {
    const form = mc.newCustomForm()
        .setTitle(isGlobal ? "§e全服公告" : "§e玩家公告")
        .addInput("§a公告内容", "§e请输入公告内容");

    player.sendForm(form, (pl, data) => {
        if (data) {
            const content = data[0];
            if (isGlobal) {
                mc.getOnlinePlayers().forEach(p => sendAnnouncement(p, "§l§e公告", content));
                pl.sendText("§a公告已发送到全服。");
            } else if (targetPlayer) {
                sendAnnouncement(targetPlayer, "§e§l管理员对你的通知", content);
                pl.sendText("§a公告已发送给 " + targetPlayer.realName + "。");
            }
        }
    });
}
function selectPlayerForAnnouncement(player) {
    const form = mc.newSimpleForm()
        .setTitle("§e选择玩家")
        .setContent("§e请选择要发送公告的玩家：");

    mc.getOnlinePlayers().forEach(pl => form.addButton(pl.realName));

    player.sendForm(form, (pl, id) => {
        if (id !== null && id < mc.getOnlinePlayers().length) {
            createAnnouncementForm(pl, false, mc.getOnlinePlayers()[id]);
        }
    });
}
